> For the complete documentation index, see [llms.txt](https://www.opal-rt.com/docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://www.opal-rt.com/docs/rt-lab/automation-api-and-scripting/python-dashboard-api/api-reference/class-reference/model.md).

# Model

*class* opalone.\_internal.models.Model(*model\_id*, *model\_type=None*)

<table data-header-hidden><thead><tr><th width="158.22222900390625"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>A model is a resource which contains diagram information that can be edited with Schematic Editor, Simulink or HYPERSIM. It belongs to a Project.</td></tr><tr><td><strong>Parameters</strong></td><td><p><strong>model_id</strong> (<em>str</em>) – The ID of the model.</p><p><strong>model_type</strong> (<em>str | ModelType</em>) – The type of the model. If omitted, the type will be evaluated on first use.</p></td></tr><tr><td><strong>Bases</strong></td><td>Ressource</td></tr></tbody></table>

## Method

### add\_block

add\_block(*library\_block\_path*)

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Add a single block to the top level of the model.</td></tr><tr><td><strong>Parameters</strong></td><td><strong>library_block_path</strong> (<em>str</em>) – The path of the block in a library.</td></tr><tr><td><strong>Returns</strong></td><td>The added block.</td></tr><tr><td><strong>Return type</strong></td><td>Block</td></tr></tbody></table>

### add\_multiple\_blocks

add\_multiple\_blocks(*library\_block\_paths*)

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Add multiple blocks to the top level of the model.</td></tr><tr><td><strong>Parameters</strong></td><td><strong>library_block_paths</strong> (<em>list[str]</em>) – The paths of the blocks in a library.</td></tr><tr><td><strong>Returns</strong></td><td>The added blocks.</td></tr><tr><td><strong>Return type</strong></td><td>list[Block]</td></tr></tbody></table>

### delete

delete()

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Delete the current model.</td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Returns</strong></td><td>None</td></tr></tbody></table>

### pause

pause()

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Method to attempt to pause a running simulation on a model.</td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Returns</strong></td><td>None</td></tr></tbody></table>

### remove\_blocks

remove\_blocks(*blocks*)

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Remove blocks from a top level of the model.</td></tr><tr><td><strong>Parameters</strong></td><td><strong>blocks</strong> (<em>str | Block | list[str|Block]</em>) – The Blocks to remove from the model, either IDs or block objects. If a list is provided, IDs and objects can be mixed.</td></tr><tr><td><strong>Returns</strong></td><td>None</td></tr></tbody></table>

### run

run()

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Method to attempt to start a simulation on a model.</td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Returns</strong></td><td>None</td></tr></tbody></table>

### stop

stop()

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Method to attempt to stop a running simulation on a model.</td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Returns</strong></td><td>None</td></tr></tbody></table>

### to\_json

to\_json(*fields*, *values*)

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Convert this resource to a serialized JSON representation.</td></tr><tr><td><strong>Parameters</strong></td><td><ul><li><strong>fields</strong> (<em>tuple[str] | list[str]</em>) – Fields to include.</li><li><strong>values</strong> (<em>tuple[object] | list[object]</em>) – The value of each field</li></ul></td></tr><tr><td><strong>Returns</strong></td><td>The serialized JSON representation.</td></tr><tr><td><strong>Return type</strong></td><td>str</td></tr></tbody></table>

## Property

### blocks

*property* block&#x73;*: dict\[str, Block]*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td><p>The list of blocks in the top Level of the model, as a mapping <em>name = block</em>. The block names are unique within the top level.</p><p>This property is read-only, it cannot be modified. However, each block might have alterable properties.</p></td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Return type</strong></td><td>dict[str, Block]</td></tr></tbody></table>

### created\_at

*property* created\_a&#x74;*: str*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>The creation date of the model.<br>This property is read-only, it cannot be modified.</td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Return type</strong></td><td>str</td></tr></tbody></table>

### datapoints

*property* datapoint&#x73;*: dict\[str, Parameter | Signal]*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td><p>The datapoints contained in this model, in the form of a mapping <em>path = datapoint</em>.</p><p>Datapoints are a concatenation of parameters and signals, and could include other elements in the future.</p><p>This property is read-only, it cannot be modified. However, each datapoint might have alterable properties.</p></td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Return type</strong></td><td>dict[str, Parameter | Signal]</td></tr></tbody></table>

### description

*property* descriptio&#x6E;*: str*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>The description of the model.</td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Return type</strong></td><td>str</td></tr></tbody></table>

### id

*property* i&#x64;*: str*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>The ID of the resource.<br>This property is read-only, it cannot be modified.</td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Return type</strong></td><td>str</td></tr></tbody></table>

### is\_grid\_visible

*property* is\_grid\_visibl&#x65;*: bool*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Indicates if the grid is <em>visible</em> (True) or not (False) on the model’s canvas.</td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Return type</strong></td><td>Bool</td></tr></tbody></table>

### is\_running

*property* is\_runnin&#x67;*: bool*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td><p>Indicates if the model is running (True) or not (False).</p><p>This property is read-only, it cannot be modified.</p></td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Return type</strong></td><td>Bool</td></tr></tbody></table>

### modified\_at

*property* modified\_a&#x74;*: str*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td><p>The last-modified date of the model.</p><p>This property is read-only, it cannot be modified.</p></td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Return type</strong></td><td>Bool</td></tr></tbody></table>

### name

*property* nam&#x65;*: str*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>The name of the model.</td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Return type</strong></td><td>str</td></tr></tbody></table>

### state

*property* stat&#x65;*: SimulationState*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td><p>The state of the model.</p><p>This property is read-only, it cannot be modified.</p></td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Return type</strong></td><td>SimulationState</td></tr></tbody></table>

### type

property type: ModelType

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td><p>The type of the model.</p><p>This property is read-only, it cannot be modified.</p></td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Return type</strong></td><td>ModelType</td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://www.opal-rt.com/docs/rt-lab/automation-api-and-scripting/python-dashboard-api/api-reference/class-reference/model.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
